// A first attempt to create a Minecraft-like system
// where you can build cubes outward from a single
// starting cube.  Use the keys t, f, v, b, h, y to
// add cubes in the six 3D directions (+-X,Y,Z) relative
// to the most recently added cube.  Inevitably, this
// interface is ridiculously hard to use, especially 
// given that the world is rotating the whole time.

// A single 3D point with integer coordinates.
class Point
{
  int x;
  int y;
  int z;

  Point( int x, int y, int z )
  {
    this.x = x;
    this.y = y;
    this.z = z;
  }
}

Point[] cubes;
Point cur;

void init()
{
  cubes = new Point[1];
  cubes[0] = new Point( 0, 0, 0 );
  cur = new Point( 0, 0, 0 );
}

void setup()
{
  size( 500, 500, P3D );
  init();
}

void draw()
{
  background( 50 );
  lights();
  fill( 200 );
  noStroke();

  translate( width/2, height/2 );
  rotateY( frameCount * 0.01 );
  scale( 50 );

  for ( Point p : cubes ) {
    pushMatrix();
    translate( p.x, p.y, p.z );
    box( 1 );
    popMatrix();
  }
}

void keyPressed()
{
  boolean ok = true;

  if ( key == 't' ) {
    --cur.y;
  } else if ( key == 'b' ) {
    ++cur.y;
  } else if ( key == 'y' ) {
    ++cur.z;
  } else if ( key == 'v' ) {
    --cur.z;
  } else if ( key == 'f' ) {
    --cur.x;
  } else if ( key == 'h' ) {
    ++cur.x;
  } else if ( key == ' ' ) {
    init();
    ok = false;
  } else {
    ok = false;
  }

  if ( ok ) {
    cubes = (Point[])append( cubes, new Point( 
      cur.x, cur.y, cur.z ) );
  }
}