// Draw a cool rotating globe of small spheres with
// random colours, just for fun.

class pt
{
  float x;
  float y;
  float z;
  color c;
  
  pt()
  {
    // This is some fairly clever mathematics to choose 
    // a random point on the surface of a sphere (which 
    // isn't as easy as it sounds).  See
    // http://mathworld.wolfram.com/SpherePointPicking.html
    float th = random( 0, TWO_PI );
    float u = random( -1, 1 );
    float rt = sqrt( 1.0 - u*u );
    x = rt * cos( th );
    y = rt * sin( th );
    z = u;
    
    // Also pick a random colour.
    c = color( random(255), random(255), random(255) );
  }
}

pt[] pts;

void setup()
{
  size( 500, 500, P3D );
  pts = new pt[ 1000 ];
  for( int idx = 0; idx < pts.length; ++idx ) {
    pts[idx] = new pt();
  } 
}

void draw()
{
  // Tone down the level of detail in each small sphere
  // to keep render times low and performance high.
  // Feel free to look up the documentation of 
  // sphereDetail() for more.
  sphereDetail( 10 );
  
  background( 50 );
  lights();
  noStroke();
  pushMatrix();
  translate( width/2, height/2, 0 );
  rotateY( frameCount * 0.01 );
  scale( 200 );
  
  for( int idx = 0; idx < pts.length; ++idx ) {
    pushMatrix();
    translate( pts[idx].x, pts[idx].y, pts[idx].z );
    fill( pts[idx].c );
    sphere( 0.02 );
    popMatrix();
  }
  
  popMatrix();
}