// The example developed in class.  Draw a 3D grid of
// spheres using triply nested for loops.  In practice
// I probably won't ask you to write triply nested loops,
// at least not often.

void setup()
{
  size( 500, 500, P3D );
}

void draw()
{
  background( 50 );
  noStroke();
  lights();

  pushMatrix();
  translate( width/2, height/2 );

  rotateY( frameCount * 0.01 );

  scale( 100 );
  fill( 255, 0, 0 );
  for ( int idx = 0; idx < 5; ++idx ) {
    for ( int jdx = 0; jdx < 5; ++jdx ) {
      for ( int kdx = 0; kdx < 5; ++kdx ) {
        pushMatrix();

        float x = map( idx, 0, 4, -1, 1 ); 
        float y = map( jdx, 0, 4, -1, 1 ); 
        float z = map( kdx, 0, 4, -1, 1 );
        translate( x, y, z ); 

        sphere( map( dist( 0.5, 0.5, 0.5, x, y, z ), 0, 2, 0.01, 0.2 ) );

        popMatrix();
      }
    }
  }

  popMatrix();
}