// A combination of P3D and controlP5 -- demonstrate
// Roll, Pitch and Yaw on a simple 3D model of an 
// airplane, to build intuition for how these map
// onto rotateX(), rotateY() and rotateZ().  Life gets
// hard when you try to use multiple rotations at the
// same time.

import controlP5.*;

PShape airplane;
ControlP5 ui;

Slider roll;
Slider pitch;
Slider yaw;

void setup()
{
  ui = new ControlP5( this );

  size( 500, 500, P3D );
  airplane = loadShape( "airplane.obj" );
  airplane.disableStyle();

  roll =  ui.addSlider( "Roll" )
    .setRange( 0, TWO_PI )
    .setPosition( 20, 20 );
  pitch = ui.addSlider( "Pitch" )
    .setRange( 0, TWO_PI )
    .setPosition( 20, 40 );
  yaw = ui.addSlider( "Yaw" )
    .setRange( 0, TWO_PI )
    .setPosition( 20, 60 );
}

void draw()
{
  background( 50 );
  lights();
  noStroke();
  fill( 255, 255, 0 );

  pushMatrix();
  translate( width/2, height/2, 0 );
  scale( 2 );
  rotateX( pitch.getValue() );
  rotateY( yaw.getValue() );
  rotateZ( roll.getValue() );
  shape( airplane );
  popMatrix();
}